/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package csbs2.ui;

/**
 *
 * @author anonymous
 */
public class SmoothInteger {

    float current, to, speed = 0, tospeed = 0, variance;
    final Object lock = new Object();

    public SmoothInteger(int aa, int variance){
        current = aa;
        to = aa;
        this.variance = variance;
    }

    public void setTo(float a){
        synchronized(lock){
            to = a;
        }
    }

    public int getTo(){
        synchronized(lock){
            return (int) to;
        }
    }

    public int value(){
        synchronized(lock){
            return (int) current;
        }
    }

    int ospeed, ocu;

    public int process(){
        synchronized(lock){
            ospeed = (int)speed;
            ocu = (int)current;
            if(to > current){
                tospeed = (to - current + (float)(variance / 10f)) / variance;
            } else {
                tospeed = -(current - to + (float)(variance / 10f)) / variance;
            }
            if(tospeed > speed){
                speed += (tospeed - speed + (float)(variance / 10f)) / (variance / 2);
                if(speed > tospeed) speed = tospeed;
            } else if(speed > tospeed){
                speed -= (speed - tospeed + (float)(variance / 10f)) / (variance / 2);
                if(speed < tospeed) speed = tospeed;
            }
            current += speed;
            if(Math.round(speed) == 0 && Math.round(current) == Math.round(to)){
                current = to;
                speed = 0;
            }
            //current +=+ (int)Math.round(Math.random() * 4)-2;
            return (int) current;
        }
    }


    public boolean done() {
        synchronized(lock){
            return (int)speed == (int)tospeed && (int)to == (int)current;
        }
    }

    void set(int nu) {
        synchronized(lock){
            current = nu;
        }
    }

}
