/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package nexus.core;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;
import nexus.lighthttp.LightHTTPProxy;

/**
 *
 * @author Luke
 */
public final class HabboConnection {

    public String habboName = "";
    public int habboId = 0;
    public boolean facebookUser = false;
    public String habboStaticFilePath = "";
    public String habboImagerUrl = "";
    public String connection_info_host = "";
    public int connection_info_port = 0;
    public String external_variables_txt = "";
    public String external_texts_txt = "";
    public String external_override_variables_txt = "";
    public String external_override_texts_txt = "";
    public String productdata_load_url = "";
    public String furnidata_load_url = "";
    public String sso_ticket = "";
    public String flash_client_url = "";
    public String user_hash = "";
    public String base = "";
    public String clientUrl = "";
    public Socket server;
    public Socket client;
    public String hotel = "";
    public String cs = "";
    public String cookie = "";
    boolean loggedin = false;
    protected HabboLogin con;

    protected boolean handleIncoming(HabboClient client, HabboPacket packet) {
        try {
            if (con.handler == null || con.handler.Receiving(client, packet)) {
                return true;
            } else {
                return false;
            }
        } catch (Exception ex) {
        }
        return true;
    }

    public HabboConnection(HabboLogin par, String cs, String hotel, String cookie) throws UnknownHostException, IOException { // parse the loader
        try {
            con = par;
            this.hotel = hotel;
            this.cookie = cookie;
            System.out.println(cs);
            /*   Below could have been done a LOT better using .substring and .indexOf, but I'm lazy.*/
            habboName = cs.split("habboName = \"")[1].split("\"")[0]; //h
            habboId = Integer.parseInt(cs.split("habboId = ")[1].split(";")[0]);//hi
            facebookUser = cs.split("facebookUser = ")[1].split(";")[0].equals("true");//f
            habboStaticFilePath = cs.split("habboStaticFilePath = \"")[1].split("\"")[0]; //s
            connection_info_host = cs.split("connection.info.host\" : \"")[1].split("\"")[0];
            connection_info_port = Integer.parseInt(cs.split("connection.info.port\" : \"")[1].split("\"")[0].contains(",") ? cs.split("connection.info.port\" : \"")[1].split("\"")[0].split(",")[0] : cs.split("connection.info.port\" : \"")[1].split("\"")[0]);
            external_variables_txt = cs.split("external.variables.txt\" : \"")[1].split("\"")[0]; //e
            external_texts_txt = cs.split("external.texts.txt\" : \"")[1].split("\"")[0]; //et
            if (cs.contains("external.override.variables.txt")) {
                external_override_variables_txt = cs.split("external.override.variables.txt\" : \"")[1].split("\"")[0]; //o
            }
            if (cs.contains("external.override.texts.txt")) {
                external_override_texts_txt = cs.split("external.override.texts.txt\" : \"")[1].split("\"")[0]; //ot
            }
            productdata_load_url = cs.split("productdata.load.url\" : \"")[1].split("\"")[0]; //p
            furnidata_load_url = cs.split("furnidata.load.url\" : \"")[1].split("\"")[0]; //fd
            sso_ticket = cs.split("\"sso.ticket\" : \"")[1].split("\"")[0]; //sso
            flash_client_url = cs.split("flash.client.url\" : \"")[1].split("\"")[0]; //c
            user_hash = cs.split("user.hash\" : \"")[1].split("\"")[0]; //u
            base = cs.split("base\" : \"")[1].split("\"")[0]; //b
            clientUrl = base + "Habbo.swf";
            cs = ("<!DOCTYPE" + cs.replace(connection_info_host, "csbs2.sulake.com").split("<!DOCTYPE")[1].replace("\"client.allow.cross.domain\" : \"0\"", "\"client.allow.cross.domain\" : \"1\""));
            cs = cs.replace(cs.split("\"client.starting\" : \"")[1].split("\"")[0], "Connecting to CSBS2");
            this.cs = cs;
//        Browser.openURL("http://fayl1861.110mb.com/csbs/loader.php?h=" + e(habboName)
//                + "&sso=" + e(sso_ticket)
//                + "&hi=" + String.valueOf(habboId)
//                + "&u=" + e(user_hash)
//                + "&b=" + e(base)
//                + "&f=" + (facebookUser ? "true" : "false")
//                + "&s=" + e(habboStaticFilePath)
//                + "&e=" + e(external_variables_txt)
//                + "&et=" + e(external_texts_txt)
//                + "&o=" + e(external_override_variables_txt)
//                + "&ot=" + e(external_override_texts_txt)
//                + "&p=" + e(productdata_load_url)
//                + "&fd=" + e(furnidata_load_url)
//                + "&c=" + e(flash_client_url));
            loggedin = true;
        } catch (Exception ee) {
            javax.swing.JOptionPane.showMessageDialog(null, "Login error (Incorrect login information?)");
        }
    }
    ServerSocket ss;

    public static String getHeader(byte[] b) {
        String s = "";
        s += (char) b[0];
        s += (char) b[1];
        return s;
    }

    public void listen() throws IOException {
        if (loggedin) {
            LightHTTPProxy lhs = new LightHTTPProxy(hotel, cookie, 922);
            lhs.setFile("/", cs.getBytes());
            lhs.Start();
            Browser.openURL("http://csbs2.sulake.com:922/");
            ss = new ServerSocket(connection_info_port); // its OVER 9000!!!!!!
            final HabboConnection me = this;

            new Thread(new Runnable() {

                public void run() {
                    try {
                        Socket c;
                        while ((c = ss.accept()) != null) {
                            new HabboClient(me, c);
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            }, "HabboConnection").start();
        }
    }
}
